<template>
    <Row class="stock-form-item" :class="styleClass">
      <template v-if="!edit">
        <!--   Text   -->
        <template v-if="options.type === 'text'">
          <div class="field-value">{{ value }}</div>
        </template>

        <!--   Password   -->
        <template v-if="options.type === 'password'">
          <div class="field-value">{{ passwordValue }}</div>
        </template>
      </template>
      <template v-if="edit">
        <!--   Text   -->
        <template v-if="options.type === 'text'">
          <input class="field-input" v-model="val" type="text" placeholder=" "></input>
        </template>

        <!--   Password   -->
        <template v-if="options.type === 'password'">
          <input  class="field-input"  v-model="val" type="password" placeholder=" "></input>
        </template>

        <!-- ERROR MESSAGE -->
        <li class="error-message" v-for="(errorMessage, index) in error" :key="index">
          {{errorMessage}}
        </li>
      </template>
      <div class="field-label">{{options.title}}</div>
    </Row>
</template>

<script>
  const emits = {
    inputEmit(data) {
      this.$emit('input', data);
    }
  };

  export default {
    name: 'StockFormItem',
    props: {
      edit: {
        type: Boolean,
        default: false,
      },
      value: {},
      options: {
        type: Object,
        default: () => { return { type: 'text' }; },
      },
      error: {
        type: Array,
        default: () => { return []; },
      }
    },
    data() {
      return {
        val: this.value,
      };
    },
    computed: {
      passwordValue() {
        let result = '';
        this.value.split('').forEach(() => {
          result += '*';
        });
        return result;
      },
      styleClass() {
        const result = [];
        if (this.edit) {
          result.push('form-edit');
        }
        if (this.error.length > 0) {
          result.push('form-error');
        }
        return result;
      },
    },
    watch: {
      val(val, oldVal) {
        this.inputEmit(this.val);
      }
    },
    methods: {
      ...emits,
    },
  }
</script>

<style lang="scss" scoped>
  .stock-form-item {
    position: relative;
    margin: 32px 0 40px 0;
    .field-value {
      padding: 5px 10px;
      border-radius: 4px;
      font-size: 22px;
    }

    .field-label {
      position: absolute;
      top: -28px;
      left: 10px;
      font-size: 18px;
    }
  }

  .stock-form-item.form-edit {
    .field-input {
      width: 100%;
      outline: 0;
      font-size: 20px;
      padding: 5px 10px;
      border-radius: 4px;
      background-color: transparent;
      transition: 0.5s;
      &::placeholder {
        color: rgba(0, 0, 0, 0);
      }
      &:focus {
        border: 1px solid #08caf4;
      }
      &:focus ~ .field-label,
      &:not(:placeholder-shown) ~ .field-label {
        top: -28px;
        color: #08caf4;
        font-size: 18px;
      }
    }

    .field-label {
      color: #fff;
      position: absolute;
      top: 5px;
      left: 10px;
      font-size: 20px;
      pointer-events: none;
      transition: 0.5s;
    }
  }

  .stock-form-item.form-error {
    .error-message {
      font-size: 16px;
    }
  }
</style>
